SystemOrganization addCategory: #'PathObjects-Export'!

Object subclass: #SPOInteractionModelExporter
	instanceVariableNames: 'interactionModel idMap idCounter output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Export'!

SPOInteractionModelExporter subclass: #SPODotExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Export'!

!SPODotExporter methodsFor: 'as yet unclassified' stamp: 'ls 12/19/2013 16:50:34.653'!
addEpilogue
	
	| layouter |
	layouter := SPOGraphvizLayoutStrategy new
		interactionModel: self interactionModel;
		yourself.
	self output nextPutAll: layouter generateGraph dot.! !

SPOInteractionModelExporter subclass: #SPOGamlExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Export'!

!SPOGamlExporter methodsFor: 'conversion' stamp: 'ls 5/1/2013 20:50:34.742'!
addEpilogue
	
	self output
		nextPutAll: '</graph>';
		nextPutAll: '</graphanimation>'.! !

!SPOGamlExporter methodsFor: 'conversion' stamp: 'ls 5/1/2013 20:50:44.306'!
addPreamble
	
	self output
		nextPutAll: '<graphanimation>';
		nextPutAll: '<graph>';
		cr.! !

!SPOGamlExporter methodsFor: 'conversion' stamp: 'ls 8/29/2013 15:48:50.503'!
convertMessageSendStep: aStep
	
	self output
		nextPutAll: '<edge id="';
		nextPutAll: self nextUniqueId asString;
		nextPutAll: '" sourceid="';
		nextPutAll: aStep sender objectId asString;
		nextPutAll: '" targetid="';
		nextPutAll: aStep receiver objectId asString;
		nextPutAll: '" />';
		cr.! !

!SPOGamlExporter methodsFor: 'conversion' stamp: 'ls 5/1/2013 20:51:43.938'!
convertObjectProxy: aProxy
	
	self output
		nextPutAll: '<node id="';
		nextPutAll: aProxy objectId asString;
		nextPutAll: '" label="';
		nextPutAll: aProxy label;
		nextPutAll: '" />';
		cr.! !

!SPOGamlExporter methodsFor: 'conversion' stamp: 'ls 8/29/2013 15:49:04.203'!
convertReturnStep: aStep
	
	self output
		nextPutAll: '<edge id="';
		nextPutAll: self nextUniqueId asString;
		nextPutAll: '" sourceid="';
		nextPutAll: aStep receiver objectId asString;
		nextPutAll: '" targetid="';
		nextPutAll: aStep sender objectId asString;
		nextPutAll: '" />';
		cr.! !

SPOInteractionModelExporter subclass: #SPOGraphMlExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Export'!

!SPOGraphMlExporter methodsFor: 'conversion' stamp: 'ls 5/1/2013 20:46:28.258'!
addEpilogue
	
	self output
		nextPutAll: '</graph>';
		cr;
		nextPutAll: '</graphml>'.! !

!SPOGraphMlExporter methodsFor: 'conversion' stamp: 'ls 5/2/2013 09:37:22.126'!
addPreamble

	self output 
		nextPutAll: '<?xml version="1.0" encoding="UTF-8"?>';
		cr;  
		nextPutAll: '<graphml xmlns="http://graphml.graphdrawing.org/xmlns" 
			xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
			xsi:schemaLocation="http://graphml.graphdrawing.org/xmlns 
			http://graphml.graphdrawing.org/xmlns/1.0/graphml.xsd"
			xmlns:y="http://www.yworks.com/xml/graphml">';
		cr;
		nextPutAll: '<key for="node" id="d1" yfiles.type="nodegraphics"/>';
		cr;
		nextPutAll: '<graph id="G" edgedefault="directed">';
		cr.! !

!SPOGraphMlExporter methodsFor: 'conversion' stamp: 'ls 8/29/2013 15:49:13.956'!
convertMessageSendStep: aStep
	
	self output
		nextPutAll: '<edge source="';
		nextPutAll: aStep sender objectId asString;
		nextPutAll: '" target="';
		nextPutAll: aStep receiver objectId asString;
		nextPutAll: '" />';
		cr.! !

!SPOGraphMlExporter methodsFor: 'conversion' stamp: 'ls 5/2/2013 10:10:11.254'!
convertObjectProxy: aProxy
	
	self output
		nextPutAll: '<node id="';
		nextPutAll: aProxy objectId asString;
		nextPutAll: '">';
      	nextPutAll: '<data key="d1">';
		nextPutAll: '<y:ShapeNode>';
		nextPutAll: '<y:Shape type="rectangle"/>';
		nextPutAll: '<y:Geometry height="30.0" width="140.0" x="0.0" y="0.0"/>';
		nextPutAll: '<y:Fill color="#FFCC00" transparent="false"/>';
		nextPutAll: '<y:BorderStyle color="#000000" type="line" width="1.0"/>';
		nextPutAll: '<y:NodeLabel>';
		nextPutAll: aProxy label;
		nextPutAll: '</y:NodeLabel>';
		nextPutAll: '</y:ShapeNode>';
		nextPutAll: '</data></node>'; 
		cr.! !

!SPOGraphMlExporter methodsFor: 'conversion' stamp: 'ls 8/29/2013 15:49:24.151'!
convertReturnStep: aStep
	
	self output
		nextPutAll: '<edge source="';
		nextPutAll: aStep receiver objectId asString;
		nextPutAll: '" target="';
		nextPutAll: aStep sender objectId asString;
		nextPutAll: '" />';
		cr.! !

!SPOInteractionModelExporter class methodsFor: 'as yet unclassified' stamp: 'ls 4/30/2013 23:17:07.57'!
convert: anInteractionModel
	
	| exporter |
	exporter := self new interactionModel: anInteractionModel.
	^ exporter convert! !

!SPOInteractionModelExporter methodsFor: 'conversion' stamp: 'ls 6/15/2013 19:50:22.128'!
addEpilogue
	
	! !

!SPOInteractionModelExporter methodsFor: 'conversion' stamp: 'ls 6/15/2013 19:50:26.45'!
addPreamble
	
	! !

!SPOInteractionModelExporter methodsFor: 'as yet unclassified' stamp: 'ls 7/9/2013 11:24:56.645'!
convert
	
	self addPreamble.
	
	self interactionModel objects
		collect: [:each | each value]
		thenDo: [:each | self convertObjectProxy: each].
	
	self interactionModel steps do: [:each |
		each isMessageStep ifTrue: [self convertMessageSendStep: each].
		each isReturnStep ifTrue: [self convertReturnStep: each]].
	
	self addEpilogue.
	^ self output contents! !

!SPOInteractionModelExporter methodsFor: 'conversion' stamp: 'ls 6/15/2013 19:50:39.347'!
convertMessageSendStep: aStep
	
	! !

!SPOInteractionModelExporter methodsFor: 'conversion' stamp: 'ls 6/15/2013 19:50:42.975'!
convertObjectProxy: aProxy
	
	! !

!SPOInteractionModelExporter methodsFor: 'conversion' stamp: 'ls 6/15/2013 19:50:46.622'!
convertReturnStep: aStep
	
	! !

!SPOInteractionModelExporter methodsFor: 'accessing' stamp: 'ls 4/30/2013 17:31:17.975'!
idCounter
	
	^ idCounter ifNil: [idCounter := 0]! !

!SPOInteractionModelExporter methodsFor: 'accessing' stamp: 'ls 4/30/2013 17:31:17.989'!
idCounter: anObject
	
	idCounter := anObject.! !

!SPOInteractionModelExporter methodsFor: 'accessing' stamp: 'ls 4/30/2013 17:28:39.451'!
idMap
	
	^ idMap ifNil: [idMap := Dictionary new]! !

!SPOInteractionModelExporter methodsFor: 'as yet unclassified' stamp: 'ls 5/1/2013 20:45:06.755'!
initialize
	
	super initialize.
	self output: (WriteStream on: String new)! !

!SPOInteractionModelExporter methodsFor: 'accessing' stamp: 'ls 4/30/2013 17:22:39.156'!
interactionModel
	
	^ interactionModel! !

!SPOInteractionModelExporter methodsFor: 'accessing' stamp: 'ls 4/30/2013 17:22:39.174'!
interactionModel: anObject
	
	interactionModel := anObject.! !

!SPOInteractionModelExporter methodsFor: 'id generation' stamp: 'ls 4/30/2013 17:30:25.094'!
nextUniqueId
	
	self idCounter: self idCounter + 1.
	^ self idCounter.! !

!SPOInteractionModelExporter methodsFor: 'accessing' stamp: 'ls 5/1/2013 20:42:25.692'!
output
	
	^ output! !

!SPOInteractionModelExporter methodsFor: 'accessing' stamp: 'ls 5/1/2013 20:42:38.702'!
output: aStream
	
	output := aStream.! !

!SPOInteractionModelExporter methodsFor: 'id generation' stamp: 'ls 4/30/2013 17:29:47.407'!
uniqueIdFor: anObject
	
	^ self idMap 
		at: anObject
		ifAbsentPut: [self nextUniqueId]! !
